' QuickSort demonstration
' Written by J. Farrell
' jdfarrell@students.wisc.edu

DEFINT A-Z
DECLARE SUB QuickSort (low, high)
DIM SHARED array(400)

' Make an array of random integers from 1-100
RANDOMIZE TIMER
FOR a = 1 TO 400
   array(a) = INT(RND * 100) + 1
NEXT

CLS
PRINT "Sorting..."
QuickSort 1, 400
PRINT "...wow, that was fast!"
FOR a = 1 TO 400
   PRINT array(a);
NEXT

END

SUB QuickSort (low, high)

' Do nothing if low >= high
IF low < high THEN
   ' Check if elements are sequential
   IF high = low + 1 THEN
      IF array(low) > array(high) THEN SWAP array(high), array(low)
   ELSE
      ' Choose a partition element and swap it with the last value in array
      partIndex = (low + high) \ 2
      partValue = array(partIndex)
      SWAP array(high), array(partIndex)
     
      ' Initialize pointers
      top = low
      bottom = high - 1
      DO
         ' Inrement the top pointer
         DO UNTIL (array(top) > partValue) OR (top > bottom)
            top = top + 1
         LOOP
         ' Decrement the bottom pointer
         DO UNTIL (array(bottom) <= partValue) OR (top > bottom)
            bottom = bottom - 1
         LOOP
         ' Swap elements if pointers have not met
         IF top < bottom THEN SWAP array(top), array(bottom)
      LOOP WHILE top < bottom
      ' Put the partition element back where it belongs
      SWAP array(top), array(high)
     
      ' Recursive calls
      QuickSort low, top - 1
      QuickSort top + 1, high
   END IF
END IF

END SUB

